Two pointers is really an easy and effective technique which is typically used for searching pairs in a sorted array.
Given a sorted array A (sorted in ascending order), having N integers, find if there exists any pair of elements (A[i], A[j]) such that their sum is equal to X.
Let’s see the naive solution.
Python3
# Naive solution to find if there is a # pair in A[0..N-1] with given sum. def isPairSum(A, N, X): for i in range (N): for j in range (N): # as equal i and j means same element if (i = = j): continue # pair exists if (A[i] + A[j] = = X): return True # as the array is sorted if (A[i] + A[j] > X): break # No pair found with given sum return 0 # Driver code arr = [ 3 , 5 , 9 , 2 , 8 , 10 , 11 ] val = 17 print (isPairSum(arr, len (arr), val)) # This code is contributed by maheshwaripiyush9 |
1
Time Complexity: O(n2)
Auxiliary Space: O(1)
Now let’s see how the two-pointer technique works. We take two pointers, one representing the first element and other representing the last element of the array, and then we add the values kept at both the pointers. If their sum is smaller than X then we shift the left pointer to right or if their sum is greater than X then we shift the right pointer to left, in order to get closer to the sum. We keep moving the pointers until we get the sum as X.
Python3
# Two pointer technique based solution to find # if there is a pair in A[0..N-1] with a given sum. def isPairSum(A, N, X): # represents first pointer i = 0 # represents second pointer j = N - 1 while (i < j): # If we find a pair if (A[i] + A[j] = = X): return True # If sum of elements at current # pointers is less, we move towards # higher values by doing i += 1 elif (A[i] + A[j] < X): i + = 1 # If sum of elements at current # pointers is more, we move towards # lower values by doing j -= 1 else : j - = 1 return 0 # array declaration arr = [ 3 , 5 , 9 , 2 , 8 , 10 , 11 ] # value to search val = 17 print (isPairSum(arr, len (arr), val)) # This code is contributed by maheshwaripiyush9. |
1
Illustration :
Time Complexity: O(n)
Auxiliary Space: O(1) since using constant space
How does this work?
The algorithm basically uses the fact that the input array is sorted. We start the sum of extreme values (smallest and largest) and conditionally move both pointers. We move left pointer i when the sum of A[i] and A[j] is less than X. We do not miss any pair because the sum is already smaller than X. Same logic applies for right pointer j.
More problems based on two pointer technique.
- Find the closest pair from two sorted arrays
- Find the pair in array whose sum is closest to x
- Find all triplets with zero sum
- Find a triplet that sum to a given value
- Find a triplet such that sum of two equals to third element
- Find four elements that sum to a given value
Please refer complete article on Two Pointers Technique for more details!